#include "StdAfx.h"
#include <initguid.h>
#include <mmreg.h>
#include "AacDecFilter.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


// g(48kHz)
#define FREQUENCY 48000

// REFERENCE_TIMËb
#define REFERENCE_TIME_SECOND 10000000LL

// 5.1ch_E~bNXݒ
/*
{̌vZ (STD-B21 6.2)

*1*2  *3k̒l vZ(*4)                      

 1 0/1 01/2 Set1                            
       11/2   Lt=a*(L+1/2*C{k*Sl)          
       21/22Rt=a*(R+1/2*C{k*Sr)          
       30     a=1/2                         

 0            Set3                            
              Lt=(1/2)*(L+1/2*C{1/2*Sl)
              Rt=(1/2)*(R+1/2*C{1/2*Sr)

*1 matrix_mixdown_idx_present
*2 pseudo_surround_enable
*3 matrix_mixdown_idx
*4 L=Left, R=Right, C=Center, Sl=Rear left, Sr=Rear right

KvȒl NeAACDecStruct.pce (NeAACDecStruct* = NeAACDecHandle) ŎQƂł邪A
̂Ƃ낻܂łĂȂB
*/
#define RSQR	(1.0 / 1.4142135623730950488016887242097)
#define DMR_CENTER		RSQR
#define DMR_FRONT		1.0
#define DMR_REAR		RSQR
#define DMR_LFE			RSQR

// Zɂ_E~bNX
#define DOWNMIX_INT

#ifdef DOWNMIX_INT
#define IDOWNMIX_DENOM	4096
#define IDOWNMIX_CENTER	((int)(DMR_CENTER * IDOWNMIX_DENOM + 0.5))
#define IDOWNMIX_FRONT	((int)(DMR_FRONT * IDOWNMIX_DENOM + 0.5))
#define IDOWNMIX_REAR	((int)(DMR_REAR * IDOWNMIX_DENOM + 0.5))
#define IDOWNMIX_LFE	((int)(DMR_LFE * IDOWNMIX_DENOM + 0.5))
#endif


CAacDecFilter::CAacDecFilter(LPUNKNOWN pUnk, HRESULT *phr)
	: CTransformFilter(AACDECFILTER_NAME, pUnk, CLSID_AACDECFILTER)
	, m_AdtsParser(&m_AacDecoder)
	, m_AacDecoder(this)
	, m_pOutSample(NULL)
	, m_byCurChannelNum(0)
	, m_bDualMono(false)
	, m_StereoMode(STEREOMODE_STEREO)
	, m_bDownMixSurround(true)
	, m_pStreamCallback(NULL)
	, m_bNormalize(false)
	, m_bAdjustStreamTime(false)
	, m_StartTime(-1)
	, m_SampleCount(0)
{
	TRACE(TEXT("CAacDecFilter::CAacDecFilter %p\n"), this);

	// fBA^Cvݒ
	m_MediaType.InitMediaType();
	m_MediaType.SetType(&MEDIATYPE_Audio);
	m_MediaType.SetSubtype(&MEDIASUBTYPE_PCM);
	m_MediaType.SetTemporalCompression(FALSE);
	m_MediaType.SetSampleSize(0);
	m_MediaType.SetFormatType(&FORMAT_WaveFormatEx);

	 // tH[}bg\̊m
#if 1
	// 2ch
	WAVEFORMATEX *pWaveInfo = reinterpret_cast<WAVEFORMATEX *>(m_MediaType.AllocFormatBuffer(sizeof(WAVEFORMATEX)));
	if (pWaveInfo == NULL) {
		*phr = E_OUTOFMEMORY;
		return;
	}
	// WAVEFORMATEX\̐ݒ(48kHz 16bit XeIŒ)
	pWaveInfo->wFormatTag = WAVE_FORMAT_PCM;
	pWaveInfo->nChannels = 2;
	pWaveInfo->nSamplesPerSec = FREQUENCY;
	pWaveInfo->wBitsPerSample = 16;
	pWaveInfo->nBlockAlign = pWaveInfo->wBitsPerSample * pWaveInfo->nChannels / 8;
	pWaveInfo->nAvgBytesPerSec = pWaveInfo->nSamplesPerSec * pWaveInfo->nBlockAlign;
#else
	// 5.1ch
	WAVEFORMATEXTENSIBLE *pWaveInfo = reinterpret_cast<WAVEFORMATEXTENSIBLE *>(m_MediaType.AllocFormatBuffer(sizeof(WAVEFORMATEXTENSIBLE)));
	if (pWaveInfo == NULL) {
		*phr = E_OUTOFMEMORY;
		return;
	}
	// WAVEFORMATEXTENSIBLE\̐ݒ(48KHz 16bit 5.1chŒ)
	pWaveInfo->Format.wFormatTag = WAVE_FORMAT_EXTENSIBLE;
	pWaveInfo->Format.nChannels = 6;
	pWaveInfo->Format.nSamplesPerSec = FREQUENCY;
	pWaveInfo->Format.wBitsPerSample = 16;
	pWaveInfo->Format.nBlockAlign = pWaveInfo->Format.wBitsPerSample * pWaveInfo->Format.nChannels / 8;
	pWaveInfo->Format.nAvgBytesPerSec = pWaveInfo->Format.nSamplesPerSec * pWaveInfo->Format.nBlockAlign;
	pWaveInfo->Format.cbSize  = sizeof(WAVEFORMATEXTENSIBLE) - sizeof(WAVEFORMATEX);
	pWaveInfo->dwChannelMask = SPEAKER_FRONT_LEFT | SPEAKER_FRONT_RIGHT |
							   SPEAKER_FRONT_CENTER | SPEAKER_LOW_FREQUENCY |
							   SPEAKER_BACK_LEFT | SPEAKER_BACK_RIGHT;
	pWaveInfo->Samples.wValidBitsPerSample = 16;
	pWaveInfo->SubFormat = MEDIASUBTYPE_PCM;
#endif

	*phr = S_OK;
}

CAacDecFilter::~CAacDecFilter(void)
{
	TRACE(TEXT("CAacDecFilter::~CAacDecFilter\n"));
}

IBaseFilter* WINAPI CAacDecFilter::CreateInstance(LPUNKNOWN pUnk, HRESULT *phr)
{
	// CX^X쐬
	CAacDecFilter *pNewFilter = new CAacDecFilter(pUnk, phr);
	if (FAILED(*phr))
		goto OnError;

	IBaseFilter *pFilter;
	*phr = pNewFilter->QueryInterface(IID_IBaseFilter, (void**)&pFilter);
	if (FAILED(*phr))
		goto OnError;

	return pFilter;

OnError:
	delete pNewFilter;
	return NULL;
}

HRESULT CAacDecFilter::CheckInputType(const CMediaType* mtIn)
{
    CheckPointer(mtIn, E_POINTER);

	// łOK

	return S_OK;
}

HRESULT CAacDecFilter::CheckTransform(const CMediaType* mtIn, const CMediaType* mtOut)
{
	CheckPointer(mtIn, E_POINTER);
	CheckPointer(mtOut, E_POINTER);

	if (*mtOut->Type() == MEDIATYPE_Audio) {
		if (*mtOut->Subtype() == MEDIASUBTYPE_PCM) {

			// GUID_NULLł̓fobOAT[ĝŃ_~[ݒ肵ĉ
			CMediaType MediaType;
			MediaType.InitMediaType();
			MediaType.SetType(&MEDIATYPE_Stream);
			MediaType.SetSubtype(&MEDIASUBTYPE_None);

			m_pInput->SetMediaType(&MediaType);

			return S_OK;
		}
	}

	return VFW_E_TYPE_NOT_ACCEPTED;
}

HRESULT CAacDecFilter::DecideBufferSize(IMemAllocator * pAllocator, ALLOCATOR_PROPERTIES *pprop)
{
	CAutoLock AutoLock(m_pLock);
	CheckPointer(pAllocator, E_POINTER);
	CheckPointer(pprop, E_POINTER);

	// obt@1΂悢
	if(!pprop->cBuffers)pprop->cBuffers = 1L;

	// Ƃ肠1MBm
	if(pprop->cbBuffer < 0x100000L)pprop->cbBuffer = 0x100000L;

	// AP[^vpeBݒ肵Ȃ
	ALLOCATOR_PROPERTIES Actual;
	HRESULT hr = pAllocator->SetProperties(pprop, &Actual);
	if(FAILED(hr))return hr;

	// v󂯓ꂽ
	if(Actual.cbBuffer < pprop->cbBuffer)return E_FAIL;

	return S_OK;
}

HRESULT CAacDecFilter::GetMediaType(int iPosition, CMediaType *pMediaType)
{
	CAutoLock AutoLock(m_pLock);
	CheckPointer(pMediaType, E_POINTER);

	if (iPosition < 0)
		return E_INVALIDARG;
	if (iPosition > 0)
		return VFW_S_NO_MORE_ITEMS;

	*pMediaType = m_MediaType;

	return S_OK;
}

HRESULT CAacDecFilter::StartStreaming(void)
{
	CAutoLock AutoLock(m_pLock);

	// ADTSp[T
	m_AdtsParser.Reset();

	// AACfR[_I[v
	if(!m_AacDecoder.OpenDecoder())
		return E_FAIL;

	m_StartTime = -1;
	m_SampleCount = 0;

	return S_OK;
}

HRESULT CAacDecFilter::StopStreaming(void)
{
	CAutoLock AutoLock(m_pLock);

	// AACfR[_N[Y
	m_AacDecoder.CloseDecoder();

	return S_OK;
}

HRESULT CAacDecFilter::BeginFlush()
{
	HRESULT hr = S_OK;

	m_AdtsParser.Reset();
	m_AacDecoder.ResetDecoder();
	m_StartTime = -1;
	m_SampleCount = 0;
	if (m_pOutput) {
		hr = m_pOutput->DeliverBeginFlush();
	}
	return hr;
}

const BYTE CAacDecFilter::GetCurrentChannelNum()
{
	if (m_byCurChannelNum == 0)
		return CHANNEL_INVALID;
	if (m_bDualMono)
		return CHANNEL_DUALMONO;
	return m_byCurChannelNum;
}

inline LONGLONG llabs(LONGLONG val)
{
	return val<0?-val:val;
}

HRESULT CAacDecFilter::Transform(IMediaSample *pIn, IMediaSample *pOut)
{
	CAutoLock AutoLock(m_pLock);

	// ̓f[^|C^擾
	BYTE *pInData;
	HRESULT hr = pIn->GetPointer(&pInData);
	if (FAILED(hr))
		return hr;

	// o̓fBATvݒ
	m_pOutSample = pOut;
	pOut->SetActualDataLength(0);

	// ADTSp[Tɓ
	m_AdtsParser.StoreEs(pInData, pIn->GetActualDataLength());

	if (pOut->GetActualDataLength() == 0)
		return S_FALSE;

	if (m_bAdjustStreamTime) {
		// Xg[Ԃۂ̃Tv̒ɐݒ肷
		REFERENCE_TIME StartTime, EndTime;

		hr = pIn->GetTime(&StartTime, &EndTime);
		if (hr == S_OK || hr == VFW_S_NO_STOP_TIME) {
			if (m_StartTime >= 0) {
				REFERENCE_TIME CurTime = m_StartTime + (m_SampleCount * REFERENCE_TIME_SECOND / FREQUENCY);
				if (llabs(StartTime - CurTime) > REFERENCE_TIME_SECOND / 5LL) {
					// TODO: Ȃ胊ZbgȂŏXɍ킹
					TRACE(TEXT("Reset audio time\n"));
					m_StartTime = StartTime;
					m_SampleCount = 0;
				}
			} else {
				m_StartTime = StartTime;
				m_SampleCount = 0;
			}
		}
		if (m_StartTime >= 0) {
			DWORD Samples = pOut->GetActualDataLength() / sizeof(short);
			if (m_bDownMixSurround || m_byCurChannelNum == 2)
				Samples /= 2;
			else
				Samples /= 6;
			StartTime = m_StartTime + (m_SampleCount * REFERENCE_TIME_SECOND / FREQUENCY);
			m_SampleCount += Samples;
			EndTime = m_StartTime + (m_SampleCount * REFERENCE_TIME_SECOND / FREQUENCY) - 1;
			pOut->SetTime(&StartTime, &EndTime);
		}
	}

	return S_OK;
}

HRESULT CAacDecFilter::Receive(IMediaSample *pSample)
{
	const AM_SAMPLE2_PROPERTIES *pProps = m_pInput->SampleProps();
	if (pProps->dwStreamId != AM_STREAM_MEDIA)
		return m_pOutput->Deliver(pSample);

	IMediaSample *pOutSample;
	HRESULT hr;

	hr = InitializeOutputSample(pSample, &pOutSample);
	if (FAILED(hr))
		return hr;
	hr = Transform(pSample, pOutSample);
	if (SUCCEEDED(hr)) {
		if (hr == S_OK) {
			hr = m_pOutput->Deliver(pOutSample);
		} else {
			hr = S_OK;
		}
		m_bSampleSkipped = FALSE;
	}
	pOutSample->Release();

	return hr;
}

void CAacDecFilter::OnPcmFrame(const CAacDecoder *pAacDecoder, const BYTE *pData, const DWORD dwSamples, const BYTE byChannel)
{
	// o̓|C^擾
	BYTE *pOutBuff = NULL;
	if (FAILED(m_pOutSample->GetPointer(&pOutBuff)))
		return;

	DWORD dwOffset = m_pOutSample->GetActualDataLength();
	DWORD dwOutSize;

	if ((!m_bDownMixSurround && byChannel != m_byCurChannelNum
								&& (byChannel == 6 || m_byCurChannelNum == 6))
			|| (m_bDownMixSurround && reinterpret_cast<WAVEFORMATEX*>(m_MediaType.Format())->nChannels > 2)) {
		// 2ch <-> 5.1ch ؂ւ
		WAVEFORMATEX *pWaveInfo = reinterpret_cast<WAVEFORMATEX *>(m_MediaType.AllocFormatBuffer(
			byChannel == 2 ? sizeof(WAVEFORMATEX) : sizeof(WAVEFORMATEXTENSIBLE)));
		if (pWaveInfo == NULL)
			return;

		if (byChannel == 2) {
			pWaveInfo->wFormatTag = WAVE_FORMAT_PCM;
			pWaveInfo->nChannels = 2;
		} else {
			WAVEFORMATEXTENSIBLE *pwfex = reinterpret_cast<WAVEFORMATEXTENSIBLE*>(pWaveInfo);

			pWaveInfo->wFormatTag = WAVE_FORMAT_EXTENSIBLE;
			pWaveInfo->nChannels = 6;
			pWaveInfo->cbSize = sizeof(WAVEFORMATEXTENSIBLE) - sizeof(WAVEFORMATEX);
			pwfex->dwChannelMask = SPEAKER_FRONT_LEFT | SPEAKER_FRONT_RIGHT |
								   SPEAKER_FRONT_CENTER | SPEAKER_LOW_FREQUENCY |
								   SPEAKER_BACK_LEFT | SPEAKER_BACK_RIGHT;
			pwfex->Samples.wValidBitsPerSample = 16;
			pwfex->SubFormat = MEDIASUBTYPE_PCM;
		}
		pWaveInfo->nSamplesPerSec = FREQUENCY;
		pWaveInfo->wBitsPerSample = 16;
		pWaveInfo->nBlockAlign = pWaveInfo->wBitsPerSample * pWaveInfo->nChannels / 8;
		pWaveInfo->nAvgBytesPerSec = pWaveInfo->nSamplesPerSec * pWaveInfo->nBlockAlign;

		/*
			̕ӂ͂Ȃ蔲
			{łIPin::QueryAccept/IPinConnection::DynamicQueryAccept
			ĂŃtH[}bgύXł邩mFׂ
		*/
		if (FAILED(m_pOutSample->SetMediaType(&m_MediaType)))
			return;
		m_pOutput->SetMediaType(&m_MediaType);

		if (dwOffset > 0) {
			if (byChannel == 2) {
				dwOffset = DownMixSurround((short*)pOutBuff, (const short*)pOutBuff, dwOffset / (sizeof(short) * 2));
			} else if (byChannel == 6) {
				// 蔲
				dwOffset *= 3;
				::ZeroMemory(pOutBuff, dwOffset);
			}
		}
	}

	m_byCurChannelNum = byChannel;
	m_bDualMono = byChannel == 2 && m_AacDecoder.GetChannelConfig() == 0;

	pOutBuff = &pOutBuff[dwOffset];
	// _E~bNX
	switch (byChannel) {
	case 1U:
		dwOutSize = DownMixMono((short *)pOutBuff, (const short *)pData, dwSamples);
		break;
	case 2U:
		dwOutSize = DownMixStereo((short *)pOutBuff, (const short *)pData, dwSamples);
		break;
	case 6U:
		if (m_bDownMixSurround) {
			dwOutSize = DownMixSurround((short *)pOutBuff, (const short *)pData, dwSamples);
		} else {
			dwOutSize = MapSurroundChannels((short *)pOutBuff, (const short *)pData, dwSamples);
		}
		break;
	default:
		return;
	}

	if (m_bNormalize)
		Normalize((short*)pOutBuff, dwOutSize / sizeof(short));

	if (m_pStreamCallback)
		m_pStreamCallback((short*)pOutBuff, dwSamples, m_bDownMixSurround ? 2 : byChannel, m_pStreamCallbackParam);

	// fBATvLTCYݒ
	m_pOutSample->SetActualDataLength(dwOffset + dwOutSize);
}

const DWORD CAacDecFilter::DownMixMono(short *pDst, const short *pSrc, const DWORD dwSamples)
{
	// 1ch  2ch d
	const short *p = pSrc, *pEnd = pSrc + dwSamples;
	short *q = pDst;

	while (p < pEnd) {
		short Value = *p++;
		*q++ = Value;	// L
		*q++ = Value;	// R
	}

	// obt@TCYԂ
	return dwSamples * (sizeof(short) * 2);
}

const DWORD CAacDecFilter::DownMixStereo(short *pDst, const short *pSrc, const DWORD dwSamples)
{
	if (m_StereoMode == STEREOMODE_STEREO) {
		// 2ch  2ch X[
		::CopyMemory(pDst, pSrc, dwSamples * (sizeof(short) * 2));
	} else {
		const short *p = pSrc, *pEnd = pSrc + dwSamples * 2;
		short *q = pDst;

		if (m_StereoMode == STEREOMODE_LEFT) {
			// ̂
			while (p < pEnd) {
				short Value = *p;
				*q++ = Value;	// L
				*q++ = Value;	// R
				p += 2;
			}
		} else {
			// Ê
			while (p < pEnd) {
				short Value = p[1];
				*q++ = Value;	// L
				*q++ = Value;	// R
				p += 2;
			}
		}
	}

	// obt@TCYԂ
	return dwSamples * (sizeof(short) * 2);
}

#ifndef DOWNMIX_INT

/*
	_Z(IWi)
*/
const DWORD CAacDecFilter::DownMixSurround(short *pDst, const short *pSrc, const DWORD dwSamples)
{
	// 5.1ch  2ch _E~bNX

	int iOutLch, iOutRch;

	for(DWORD dwPos = 0UL ; dwPos < dwSamples ; dwPos++){
		// _E~bNX
		iOutLch = (int)(
					(double)pSrc[dwPos * 6UL + 1UL]	* DMR_FRONT		+
					(double)pSrc[dwPos * 6UL + 3UL]	* DMR_REAR		+
					(double)pSrc[dwPos * 6UL + 0UL]	* DMR_CENTER	+
					(double)pSrc[dwPos * 6UL + 5UL]	* DMR_LFE
					);

		iOutRch = (int)(
					(double)pSrc[dwPos * 6UL + 2UL]	* DMR_FRONT		+
					(double)pSrc[dwPos * 6UL + 4UL]	* DMR_REAR		+
					(double)pSrc[dwPos * 6UL + 0UL]	* DMR_CENTER	+
					(double)pSrc[dwPos * 6UL + 5UL]	* DMR_LFE
					);

		// Nbv
		if(iOutLch > 32767L)iOutLch = 32767L;
		else if(iOutLch < -32768L)iOutLch = -32768L;

		if(iOutRch > 32767L)iOutRch = 32767L;
		else if(iOutRch < -32768L)iOutRch = -32768L;

		pDst[dwPos * 2UL + 0UL] = (short)iOutLch;	// L
		pDst[dwPos * 2UL + 1UL] = (short)iOutRch;	// R
		}

	// obt@TCYԂ
	return dwSamples * (sizeof(short) * 2);
}

#else	// DOWNMIX_INT

/*
	Z
*/
const DWORD CAacDecFilter::DownMixSurround(short *pDst, const short *pSrc, const DWORD dwSamples)
{
	// 5.1ch  2ch _E~bNX

	int iOutLch, iOutRch;

	for (DWORD dwPos = 0UL ; dwPos < dwSamples ; dwPos++) {
		// _E~bNX
		iOutLch =	((int)pSrc[dwPos * 6UL + 1UL] * IDOWNMIX_FRONT	+
					 (int)pSrc[dwPos * 6UL + 3UL] * IDOWNMIX_REAR	+
					 (int)pSrc[dwPos * 6UL + 0UL] * IDOWNMIX_CENTER	+
					 (int)pSrc[dwPos * 6UL + 5UL] * IDOWNMIX_LFE) /
					IDOWNMIX_DENOM;

		iOutRch =	((int)pSrc[dwPos * 6UL + 2UL] * IDOWNMIX_FRONT	+
					 (int)pSrc[dwPos * 6UL + 4UL] * IDOWNMIX_REAR	+
					 (int)pSrc[dwPos * 6UL + 0UL] * IDOWNMIX_CENTER	+
					 (int)pSrc[dwPos * 6UL + 5UL] * IDOWNMIX_LFE) /
					IDOWNMIX_DENOM;

		// Nbv
		if(iOutLch > 32767)iOutLch = 32767;
		else if(iOutLch < -32768L)iOutLch = -32768;

		if(iOutRch > 32767)iOutRch = 32767;
		else if(iOutRch < -32768)iOutRch = -32768;

		pDst[dwPos * 2UL + 0UL] = (short)iOutLch;	// L
		pDst[dwPos * 2UL + 1UL] = (short)iOutRch;	// R
	}

	// obt@TCYԂ
	return dwSamples * (sizeof(short) * 2);
}

#endif	// DOWNMIX_INT


const DWORD CAacDecFilter::MapSurroundChannels(short *pDst, const short *pSrc, const DWORD dwSamples)
{
	for (DWORD i = 0 ; i < dwSamples ; i++) {
		pDst[i * 6 + 0] = pSrc[i * 6 + 1];	// Front left
		pDst[i * 6 + 1] = pSrc[i * 6 + 2];	// Font right
		pDst[i * 6 + 2] = pSrc[i * 6 + 0];	// Front center
		pDst[i * 6 + 3] = pSrc[i * 6 + 5];	// Low frequency
		pDst[i * 6 + 4] = pSrc[i * 6 + 3];	// Back left
		pDst[i * 6 + 5] = pSrc[i * 6 + 4];	// Back right
	}

	// obt@TCYԂ
	return dwSamples * (sizeof(short) * 6);
}


bool CAacDecFilter::ResetDecoder()
{
	CAutoLock AutoLock(m_pLock);

	return m_AacDecoder.ResetDecoder();
}


bool CAacDecFilter::SetStereoMode(int StereoMode)
{
	switch (StereoMode) {
	case STEREOMODE_STEREO:
	case STEREOMODE_LEFT:
	case STEREOMODE_RIGHT:
		m_StereoMode = StereoMode;
		return true;
	}
	return false;
}


bool CAacDecFilter::SetDownMixSurround(bool bDownMix)
{
	CAutoLock AutoLock(m_pLock);

	m_bDownMixSurround = bDownMix;
	return true;
}


bool CAacDecFilter::SetNormalize(bool bNormalize,float Level)
{
	CAutoLock AutoLock(m_pLock);

	m_bNormalize = bNormalize;
	m_NormalizeLevel = Level;
	return true;
}


bool CAacDecFilter::GetNormalize(float *pLevel) const
{
	if (pLevel)
		*pLevel = m_NormalizeLevel;
	return m_bNormalize;
}


#define NORMALIZE_SHIFT_BITS	12
#define NORMALIZE_DENOM			(1<<NORMALIZE_SHIFT_BITS)

/*
	{̓_E~bNXƓɍsǂ
*/
void CAacDecFilter::Normalize(short *pBuffer,DWORD Samples)
{
	int Level = (int)(m_NormalizeLevel * (float)NORMALIZE_DENOM);
	short *p, *pEnd;
	int Value;

	p= pBuffer;
	pEnd= p + Samples;
	while (p < pEnd) {
		Value = (*p * Level) / NORMALIZE_DENOM;
		*p++ = Value > 32767 ? 32767 : Value < -32768 ? -32768 : Value;
	}
}


bool CAacDecFilter::SetAdjustStreamTime(bool bAdjust)
{
	CAutoLock AutoLock(m_pLock);

	m_bAdjustStreamTime = bAdjust;

	m_StartTime = -1;
	m_SampleCount = 0;

	return true;
}


bool CAacDecFilter::SetStreamCallback(StreamCallback pCallback, void *pParam)
{
	CAutoLock AutoLock(m_pLock);

	m_pStreamCallback = pCallback;
	m_pStreamCallbackParam = pParam;

	return true;
}
